#include <vector>
#include <iostream>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>

using namespace std;

struct Input
{
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data(istream& inx, bool prompt)
{
    size_t number_count;
    if (prompt) cerr << "Enter number count: ";
    inx >> number_count;


    Input in;
    in.numbers.resize(number_count);

    vector<double> numbers(number_count);
    if (prompt) cerr << "Input some numbers: ";
    for (int i = 0; i < number_count; i++)
    {
        inx >> in.numbers[i];
    }

    if (prompt) cerr << "Enter bin count: ";
    inx >> in.bin_count;
    return in;
}

int main(int argc, char* argv[])
{
    if (argc > 1) {
        cout << "argc = " << argc << endl;
        for (int i = 0; i < argc; ++i) {
            cout << "argv[" << i << "] = " << argv[i] << endl;
        }
        return 0;
    }

    curl_global_init(CURL_GLOBAL_ALL);

    auto in = input_data(cin, true);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);

}
